<?php

    header("Cache-Control: no-cache");
    header("Pragma: no-cache");
	
	
	$responseStatus = gpc("responsestatus");
	
	if ($responseStatus == "200")
		header("HTTP/1.1 200 OK\n\n");
    else if ($responseStatus == "204")
		header("HTTP/1.1 204 No Content\n\n");
	else if ($responseStatus == "403")
		header("HTTP/1.1 403 Forbidden\n\n");
    else if ($responseStatus == "404")
	    header("HTTP/1.1 404 Not Found\n\n");
    else if ($responseStatus == "500")
	    header("HTTP/1.1 500 Internal Server Error\n\n");
    else if ($responseStatus == "501")
	    header("HTTP/1.1 501 Not Implemented\n\n");
    else if ($responseStatus == "502")
	    header("HTTP/1.1 502 Bad Gateway\n\n");
    else if ($responseStatus == "503")
	    header("HTTP/1.1 503 Service Unavailable\n\n");
    else if ($responseStatus == "504")
	    header("HTTP/1.1 504 Gateway Timeout\n\n");
    else if ($responseStatus == "505")
	    header("HTTP/1.1 505 HTTP Version Not Supported\n\n");

	if ($responseStatus && $responseStatus != "200")exit;	

    $headers = getallheaders();
	
	echo "<strong>Headers</strong><div class='data'>";
	foreach($headers as $key => $value)
	    echo "$key: $value <br />";
	echo "</div>";
	
	echo "<strong>Payload</strong><div class='data'>";
	
	$varList = "";
	$varString = "";
	
	if (count($_GET) > 0)
	{
		$varString = "GET Query String: ";
		$varString .= $_SERVER['QUERY_STRING'];
		foreach($_GET as $key => $value) 
		{
			$varList .= "$key = $value <br>\n";
		}
		
		$varString .= "<br />";
	}
    else if (count($_POST) > 0)
	{
		$varString = "POST Input: ";
		foreach($_POST as $key => $value) 
		{
			if ($varString != "POST Input: ")
				$varString .= "&";
			$varString .= urlencode($key) . "=" . urlencode($value);
	        $varList .= "$key = $value <br>\n";
		}
		$varString .= "<br />";
	}
	else
		$varString = "N/A";
	
	echo $varString;
	echo $varList;
	echo "</div>";
	
	
/* Helper functions */
function gpc($name)
{
    if (isset($_GET[$name]))
	return $_GET[$name];
    else if (isset($_POST[$name]))
	return $_POST[$name];
    else if (isset($_COOKIE[$name]))
	return $_COOKIE[$name];
    else
	return "";
}
?>
